(require "error-lib.ss")

(define-signature masterS (repl))

(define masterU
  (unit/sig masterS (import errorS (plt : plt:userspace^))

    (define COLORS (list 'black 'white 'red 'blue 'green 'gold 'pink 'brown 'purple 'navy))
    (define COL# (length COLORS))

    (define STOPS (list 'PerfectGuess 'perfect_guess 'perfect!))

    (define (repl check-guess)
      ;; --- error checks on arguments:
      (check-proc 'repl check-guess 4 'first 'argument)
      (printf "Welcome to MasterMind!~n")
      ;; --- check-guess is a procedure of 4 arguments
      (let* ((c1 (list-ref COLORS (random COL#)))
	     (c2 (list-ref COLORS (random COL#)))
	     (ANS-FORM "Not quite, but here is a clue: ~a~n"))
	(letrec ([check-input
		   (lambda (in next)
			  (cond
			    ((eq? in 'quit)
			     (printf "The answers were ~s and ~s." c1 c2))
			    ((not (symbol? in))
			     (printf "Your input must be a sequence of letters, e.g. red.")
			     (printf "Try again!~n")
			     (repl))
			    ((not (member in COLORS))
			     (printf "A color is one of:~s~n" COLORS)
			     (printf "You may end the game by typing the word quit.~n")
			     (printf "Try again!~n")
			     (repl))
			    (else (next in))))]
		 [repl (lambda ()
			 (display "Your next two guesses please: ") ; (flush-output)
			 (check-input (read) 
			   (lambda (in1)
			     (check-input (read) 
			       (lambda (in2)
				 (let ((result (check-guess c1 c2 in1 in2)))
				   (if (memq result STOPS)
				       (printf "Congratulations!")
				       (begin
					 (printf ANS-FORM result)
					 (repl)))))))))])
	  (printf "You may terminate the game by typing `quit' instead of a guess.~n")
	  (repl))))))

(compound-unit/sig
  (import (PLT : plt:userspace^))
  (link
    (ERR  : errorS (errorU))
    (DRAW : masterS (masterU ERR PLT)))
  (export (open DRAW)))
